# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_blueprint_lib.api_client import ApiClient


class BlueprintApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_blueprint_using_post(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_using_post(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiBlueprintsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_blueprint_using_post_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_blueprint_using_post_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_blueprint_using_post_with_http_info(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_using_post_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiBlueprintsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_blueprint_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_blueprint_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiBlueprintsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_blueprint_version_using_post(self, body, blueprint_id, **kwargs):  # noqa: E501
        """Creates version for the given blueprint ID  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_version_using_post(body, blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param BlueprintIdVersionsBody body: (required)
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_blueprint_version_using_post_with_http_info(body, blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.create_blueprint_version_using_post_with_http_info(body, blueprint_id, **kwargs)  # noqa: E501
            return data

    def create_blueprint_version_using_post_with_http_info(self, body, blueprint_id, **kwargs):  # noqa: E501
        """Creates version for the given blueprint ID  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_version_using_post_with_http_info(body, blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param BlueprintIdVersionsBody body: (required)
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'blueprint_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_blueprint_version_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_blueprint_version_using_post`")  # noqa: E501
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `create_blueprint_version_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_blueprint_using_delete(self, blueprint_id, **kwargs):  # noqa: E501
        """Deletes a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_blueprint_using_delete(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_blueprint_using_delete_with_http_info(blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_blueprint_using_delete_with_http_info(blueprint_id, **kwargs)  # noqa: E501
            return data

    def delete_blueprint_using_delete_with_http_info(self, blueprint_id, **kwargs):  # noqa: E501
        """Deletes a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_blueprint_using_delete_with_http_info(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_blueprint_using_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `delete_blueprint_using_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_inputs_schema_using_get(self, blueprint_id, **kwargs):  # noqa: E501
        """Returns blueprint inputs schema  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_inputs_schema_using_get(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_inputs_schema_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_inputs_schema_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_inputs_schema_using_get_with_http_info(self, blueprint_id, **kwargs):  # noqa: E501
        """Returns blueprint inputs schema  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_inputs_schema_using_get_with_http_info(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_inputs_schema_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `get_blueprint_inputs_schema_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/inputs-schema', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_using_get(self, blueprint_id, **kwargs):  # noqa: E501
        """Returns blueprint details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_using_get(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param list[str] select: Fields to include in content.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_using_get_with_http_info(self, blueprint_id, **kwargs):  # noqa: E501
        """Returns blueprint details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_using_get_with_http_info(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param list[str] select: Fields to include in content.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'select', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `get_blueprint_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('$select', params['select']))  # noqa: E501
            collection_formats['$select'] = 'multi'  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_version_inputs_schema_using_get(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Returns blueprint version inputs schema  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_version_inputs_schema_using_get(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_version_inputs_schema_using_get_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_version_inputs_schema_using_get_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
            return data

    def get_blueprint_version_inputs_schema_using_get_with_http_info(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Returns blueprint version inputs schema  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_version_inputs_schema_using_get_with_http_info(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'version', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_version_inputs_schema_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `get_blueprint_version_inputs_schema_using_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_blueprint_version_inputs_schema_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions/{version}/inputs-schema', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_version_using_get(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Returns versioned blueprint details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_version_using_get(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param list[str] select: Fields to include in content.
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_version_using_get_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_version_using_get_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
            return data

    def get_blueprint_version_using_get_with_http_info(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Returns versioned blueprint details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_version_using_get_with_http_info(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param list[str] select: Fields to include in content.
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'version', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_version_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `get_blueprint_version_using_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_blueprint_version_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('$select', params['select']))  # noqa: E501
            collection_formats['$select'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions/{version}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_blueprint_versions_using_get(self, blueprint_id, **kwargs):  # noqa: E501
        """Lists blueprint versions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprint_versions_using_get(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str version: Filter by version
        :param list[str] select: Fields to include in content.
        :param str status: Filter by blueprint status: versioned / released
        :param list[str] property_groups: Filter versions with any of the specified property groups
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, name, version.
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_blueprint_versions_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.list_blueprint_versions_using_get_with_http_info(blueprint_id, **kwargs)  # noqa: E501
            return data

    def list_blueprint_versions_using_get_with_http_info(self, blueprint_id, **kwargs):  # noqa: E501
        """Lists blueprint versions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprint_versions_using_get_with_http_info(blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str version: Filter by version
        :param list[str] select: Fields to include in content.
        :param str status: Filter by blueprint status: versioned / released
        :param list[str] property_groups: Filter versions with any of the specified property groups
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, name, version.
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'page', 'size', 'sort', 'version', 'select', 'status', 'property_groups', 'api_version', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_blueprint_versions_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `list_blueprint_versions_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501
        if 'select' in params:
            query_params.append(('$select', params['select']))  # noqa: E501
            collection_formats['$select'] = 'multi'  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'property_groups' in params:
            query_params.append(('propertyGroups', params['property_groups']))  # noqa: E501
            collection_formats['propertyGroups'] = 'multi'  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2004',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_blueprints_using_get(self, **kwargs):  # noqa: E501
        """Lists draft blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprints_using_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] select: Fields to include in content.
        :param str name: Filter by name
        :param str search: Search by name and description
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param list[str] property_groups: Filter blueprints with any of the specified property groups
        :param bool versioned: Filter blueprints with at least one version
        :param bool released: Filter blueprints with at least one released version
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, name.
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_blueprints_using_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_blueprints_using_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_blueprints_using_get_with_http_info(self, **kwargs):  # noqa: E501
        """Lists draft blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprints_using_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] select: Fields to include in content.
        :param str name: Filter by name
        :param str search: Search by name and description
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param list[str] property_groups: Filter blueprints with any of the specified property groups
        :param bool versioned: Filter blueprints with at least one version
        :param bool released: Filter blueprints with at least one released version
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, name.
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'size', 'sort', 'select', 'name', 'search', 'projects', 'property_groups', 'versioned', 'released', 'api_version', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_blueprints_using_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'select' in params:
            query_params.append(('$select', params['select']))  # noqa: E501
            collection_formats['$select'] = 'multi'  # noqa: E501
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501
        if 'search' in params:
            query_params.append(('search', params['search']))  # noqa: E501
        if 'projects' in params:
            query_params.append(('projects', params['projects']))  # noqa: E501
            collection_formats['projects'] = 'multi'  # noqa: E501
        if 'property_groups' in params:
            query_params.append(('propertyGroups', params['property_groups']))  # noqa: E501
            collection_formats['propertyGroups'] = 'multi'  # noqa: E501
        if 'versioned' in params:
            query_params.append(('versioned', params['versioned']))  # noqa: E501
        if 'released' in params:
            query_params.append(('released', params['released']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def release_blueprint_version_using_post(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Release versioned blueprint to catalog  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.release_blueprint_version_using_post(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.release_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.release_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
            return data

    def release_blueprint_version_using_post_with_http_info(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Release versioned blueprint to catalog  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.release_blueprint_version_using_post_with_http_info(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'version', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method release_blueprint_version_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `release_blueprint_version_using_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `release_blueprint_version_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions/{version}/actions/release', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def restore_blueprint_version_using_post(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Restores content of draft from versioned blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.restore_blueprint_version_using_post(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.restore_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.restore_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
            return data

    def restore_blueprint_version_using_post_with_http_info(self, blueprint_id, version, **kwargs):  # noqa: E501
        """Restores content of draft from versioned blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.restore_blueprint_version_using_post_with_http_info(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'version', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method restore_blueprint_version_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `restore_blueprint_version_using_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `restore_blueprint_version_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions/{version}/actions/restore', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiBlueprintsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def un_release_blueprint_version_using_post(self, blueprint_id, version, **kwargs):  # noqa: E501
        """UnRelease versioned blueprint from catalog  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.un_release_blueprint_version_using_post(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.un_release_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.un_release_blueprint_version_using_post_with_http_info(blueprint_id, version, **kwargs)  # noqa: E501
            return data

    def un_release_blueprint_version_using_post_with_http_info(self, blueprint_id, version, **kwargs):  # noqa: E501
        """UnRelease versioned blueprint from catalog  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.un_release_blueprint_version_using_post_with_http_info(blueprint_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str blueprint_id: (required)
        :param str version: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse201
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['blueprint_id', 'version', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method un_release_blueprint_version_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `un_release_blueprint_version_using_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `un_release_blueprint_version_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}/versions/{version}/actions/unrelease', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse201',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_blueprint_using_put(self, body, blueprint_id, **kwargs):  # noqa: E501
        """Updates a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_blueprint_using_put(body, blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param BlueprintsBlueprintIdBody body: (required)
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: BlueprintsBlueprintIdBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_blueprint_using_put_with_http_info(body, blueprint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_blueprint_using_put_with_http_info(body, blueprint_id, **kwargs)  # noqa: E501
            return data

    def update_blueprint_using_put_with_http_info(self, body, blueprint_id, **kwargs):  # noqa: E501
        """Updates a blueprint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_blueprint_using_put_with_http_info(body, blueprint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param BlueprintsBlueprintIdBody body: (required)
        :param str blueprint_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: BlueprintsBlueprintIdBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'blueprint_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_blueprint_using_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_blueprint_using_put`")  # noqa: E501
        # verify the required parameter 'blueprint_id' is set
        if ('blueprint_id' not in params or
                params['blueprint_id'] is None):
            raise ValueError("Missing the required parameter `blueprint_id` when calling `update_blueprint_using_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'blueprint_id' in params:
            path_params['blueprintId'] = params['blueprint_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprints/{blueprintId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BlueprintsBlueprintIdBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
